﻿// Spyrograph2 (Double Spyrograph) - Jim Bumgardner
// Repair after spyrograph is fixed...

SW = Stage.width;
SH = Stage.height;
CX = Stage.width/2;
CY = (Stage.height-100)/2;
kNumberTrails = 200;

ringRad  = SW/2;
discRadR = .81;
disc2RadR = .81;
penRadR = .7;
speed   = 0.3;
lineThick = 4;
showGuide = true;
lastX = CX;
lastY = CY;
angleDisc = 0;

guide_mc = _root.createEmptyMovieClip("guide_mc", 50);

// This is used for drawing the guide
MovieClip.prototype.drawCircle = function(x,y,radius)
{
	var r = radius;
	var degToRad = Math.PI/180;
	var n= 8;
	
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = bA*degToRad;
	var cangle = angle-theta/2;
	
	this.moveTo(x+r, y);
	for (var i=0;i < n;i++) 
	{
		angle += theta;
		cangle += theta;
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		this.curveTo(x+cX,y+cY, x+endX,y+endY);
	}
}


guide_mc.onEnterFrame = function()
{
  var discRad = ringRad*discRadR;
  var disc2Rad = discRad*disc2RadR;
  var penRad = disc2Rad*penRadR;
  this.clear();

  // Basic spyrograph math...

  // angle of disc
  if (!_root.isAdjusting)
	  angleDisc += speed*discRadR;
  
  // center of disc 1
  sx = CX+Math.cos(angleDisc)*(ringRad-discRad);
  sy = CX+Math.sin(angleDisc)*(ringRad-discRad);
  if (!_root.isAdjusting)
    angleDisc2 = angleDisc-angleDisc*ringRad/discRad;
  sx2 = sx+Math.cos(angleDisc2)*(discRad-disc2Rad);
  sy2 = sy+Math.sin(angleDisc2)*(discRad-disc2Rad);
  if (!_root.isAdjusting)
    angPen = angleDisc2-angleDisc2*discRad/disc2Rad;

  // position of pen
  lastX = sx2+Math.cos(angPen)*penRad;
  lastY = sy2+Math.sin(angPen)*penRad;

  // compute point we're curving thru (cx,cy) for curveTo command
  var cAngleDisc = (angleDisc-speed*discRadR/2);
  var csx = CX+Math.cos(cAngleDisc)*(ringRad-discRad);
  var csy = CX+Math.sin(cAngleDisc)*(ringRad-discRad);
  var cAngleDisc2 = cAngleDisc-cAngleDisc*ringRad/discRad;
  var csx2 = csx+Math.cos(cAngleDisc2)*(discRad-disc2Rad);
  var csy2 = csy+Math.sin(cAngleDisc2)*(discRad-disc2Rad);
  var cAngPen = cAngleDisc2-cAngleDisc2*discRad/disc2Rad;
  var cRad = penRad/Math.cos(angPen-cAngPen);
  var lcx = csx2+Math.cos(cAngPen)*cRad;
  var lcy = csy2+Math.sin(cAngPen)*cRad;
 
  if (showGuide || _root.isAdjusting) 
  {  
     var alphaScale = _root.isAdjusting? 1 : .7;
     this.lineStyle(4,0x888888,100*alphaScale);
     this.drawCircle(sx,sy,discRad);
     this.drawCircle(sx2,sy2,disc2Rad);
     this.drawCircle(lastX,lastY,1+lineThick);
     this.lineStyle(2,0x888888,100*alphaScale);
     this.moveTo(sx-Math.cos(angleDisc2)*discRad, sy-Math.sin(angleDisc2)*discRad);
     this.lineTo(sx+Math.cos(angleDisc2)*discRad, sy+Math.sin(angleDisc2)*discRad);
     this.moveTo(sx2-Math.cos(angPen)*disc2Rad, sy2-Math.sin(angPen)*disc2Rad);
     this.lineTo(sx2+Math.cos(angPen)*disc2Rad, sy2+Math.sin(angPen)*disc2Rad);
  }

  if (!isAdjusting)
  {
	  for (var i = 0; i < kNumberTrails; i++)
	  {
		dotArray[i].x = dotArray[i+1].x;
		dotArray[i].y = dotArray[i+1].y;
		dotArray[i].cx = dotArray[i+1].cx;
		dotArray[i].cy = dotArray[i+1].cy;
	  }
	  dotArray[kNumberTrails].x = lastX;
	  dotArray[kNumberTrails].y = lastY;
	  dotArray[kNumberTrails].cx = lcx;
	  dotArray[kNumberTrails].cy = lcy;
  }

  var alphaScale = _root.isAdjusting? .1 : 1;
  this.moveTo(dotArray[0].x, dotArray[0].y);
	
  for (var i = 0; i <= kNumberTrails; i++) 
  {
    this.lineStyle(lineThick,dotArray[i].clr, dotArray[i].alpha*alphaScale);
    this.curveTo(dotArray[i].cx,dotArray[i].cy, dotArray[i].x, dotArray[i].y);
  }
}


getRainbowColor = function(r) // r is 0 - 1  - returns a bright color
{
	var a = r*Math.PI*2;
	var r = 128+Math.cos(a)*127;
	var b = 128+Math.cos(a+2*Math.PI/3)*127;
	var g = 128+Math.cos(a+4*Math.PI/3)*127;
	return (r << 16) | (g << 8) | b;
}

// get initial pen position...
var discRad = ringRad*discRadR;
var disc2Rad = discRad*disc2RadR;
var penRad = discRad*penRadR;
var sx = CX+Math.cos(0)*(ringRad-discRad);
var sy = CX+Math.sin(0)*(ringRad-discRad);
var sx2 = sx+Math.cos(0)*(discRad-disc2Rad);
var sy2 = sy+Math.sin(0)*(discRad-disc2Rad);
lastX = sx2+Math.cos(0)*penRad; // pen position
lastY = sy2+Math.sin(0)*penRad;

dotArray = [];
for (i = 0; i <= kNumberTrails; ++i) {
	var elem = [];
	elem.x = elem.cx = lastX;
	elem.y = elem.cy = lastY;
	elem.clr = getRainbowColor(i/kNumberTrails);
	elem.alpha = i < 20? i*100/20 : 100;
	dotArray[i] = elem;
}

resetDots = function()
{
	for (i = 0; i < kNumberTrails; ++i) 
	{
		dotArray[i].x = dotArray[kNumberTrails].x;
		dotArray[i].y = dotArray[kNumberTrails].y;
		dotArray[i].cx = dotArray[kNumberTrails].cx;
		dotArray[i].cy = dotArray[kNumberTrails].cy;
	}
}

// GUI STUFF - not strictly necessary for spyrograph stuff...
MovieClip.prototype.setupSlider = function(lab,min,max,val,changeFunc)
{
   this.minv = min;
   this.maxv = max;
   this.range = max - min;
   this.val = val;
   this.changeFunc = changeFunc;
   this.its_label.text = lab;
   this.knob_mc.useHandCursor = true;
   this.knob_mc._x = (this.val - this.minv)*this.bar_mc._width/this.range;
   this.setTextVal = function()
   {
	  if (this.isInteger)
		  this.its_value.text = Math.floor(this.val);
	  else if (this.range < 10)
		  this.its_value.text = Math.round(this.val*100)/100;
	  else if (this.range < 50)
		  this.its_value.text = Math.round(this.val*10)/10;
	  else
		  this.its_value.text = Math.round(this.val);
   }
   this.setTextVal();
   this.changeFunc(this.val);

   this.onMouseMove = function() 
   {
	  if (!this.dragging)
		return;
	  x = this.knob_mc._x;
	  var r = x/this.bar_mc._width;
	  this.val = this.minv + r*this.range;
	  this.setTextVal();
	  this.changeFunc(this.val);
   };
   this.knob_mc.onPress = function() { _root.isAdjusting = true; this._parent.dragging = true; this.startDrag(false,0,this._y,this._parent.bar_mc._width,this._y); };
   this.knob_mc.onReleaseOutside = this.knob_mc.onRelease = function() { _root.isAdjusting = false; this._parent.dragging = false; this.stopDrag(); };
}

Movieclip.prototype.setupButton = function(lab, pressFunc)
{
	this.label_txt.text = lab;
	this.label_txt.textColor = 0x000000;
	this.light_mc._alpha = 0;
	this.useHandCursor = true;
	this.pressFunc = pressFunc;
	this.onRollOver = function() { this.label_txt.textColor = 0xFFFFFF; }
	this.onRelease = function() { this.pressFunc(); this.label_txt.textColor = 0x000000; };
	this.onRollOut = this.onReleaseOutside = function() { this.label_txt.textColor = 0x000000; };
}

Movieclip.prototype.setupToggleButton = function(lab, initState, toggleFunc)
{
	this.label_txt.text = lab;
	this.state = initState;
	this.useHandCursor = true;
	this.toggleFunc = toggleFunc;
    this.setState = function(s)
		{
			this.state = s;
			this.toggleFunc(this.state);
			this.showState(); 
		};

	this.showState = function() { this.label_txt.textColor = this.state?  0xFF4444 : 0x000000; 
								 };
	this.onRelease = function() { this.setState(!this.state); };
	this.onRollOut = this.onReleaseOutside = this.showState;
	this.showState();
}


slider1_mc.setupSlider('disc 1 size',0,1, discRadR,function(t) { discRadR = t; } );
slider2_mc.setupSlider('disc 2 size',0,1, discRadR,function(t) { disc2RadR = t; } );
slider3_mc.setupSlider('pen offset',0,1, penRadR,function(t) { penRadR = t; } );
button1_mc.setupToggleButton("guide", showGuide, function(t) { showGuide = t; });
button2_mc.setupButton("clear", function() { resetDots(); });
